 /******************************************************************** 
 *
 * Title  :  CSE 142 Autumn 98 hw4.2
 * Usage  :  None, really. Just does some graphical weather stuff 
 *           for the amusemant of all.
 * 
 * Author :  Kelly Princehouse
 * Contact:  squiddy@u.washington.edu
 *
 * Notes  :  Try zapping the creature with lightning when she pops up.
 *           Oh, some spacing may look odd... it butchered some tabs
 *           when I FTP'd it, and I may have missed a couple.
 *
 ********************************************************************/

/****************************
*     Preprocessor          *
****************************/

#include "gp142.h"
#include <stdio.h>
#include <math.h>
#include <time.h>

#define TRUE                 1
#define FALSE                0

#define BUTTON_HEIGHT        35
#define BUTTON_WIDTH         100
#define NUM_BUTTONS          9

#define XMAX                 GP142_XMAX
#define YMAX                 GP142_YMAX

#define SELECTED_COLOR       RED 
#define UNSELECTED_COLOR     GREEN

#define MAX_PRECIP_EVENTS    500

#define GROUND               (-3 * (YMAX / 5) - rand() % 200)

/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn. */
#define FILL                 0

/* Types of precipitations we support. */
#define NONE                 0
#define RAIN                 1
#define SNOW                 2
#define HAIL                 3
#define LIGHTNING            4

/* If you add new types of percip, you may need to change this. */
#define MAX_PRECIP_TYPES     2

/* Possible places for mouse clicks. */
#define BUTTON               1

#define WINDMILL_RADIUS      80
#define PI                   3.14
#define WINDMILL_BLADE_SIZE  .3
#define WINDMILL_X_SQUISH    .9
#define WINDMILL_X           -163
#define WINDMILL_Y           -83
#define WINDMILL_SPEED       10.0

/* Maximum number of lightning branches (over 1). */
#define LIGHTNING_SPLITS     4

/* This says how many drops are left when the 'Fewer' button is */
/* activated.                                                   */
#define FEWER_REMAIN         (total_precip / 2)

/****************************
*     Prototypes            *
****************************/

/* Changes elements in from 'offset' to 'offset + size' in */
/* Array[] to value.                                       */
void fill_array( int Array[], int offset, int size, int value);


/* Redraw all the buttons. */
void DrawButtons(int current_precip, int current_color);

/* Erase all the precipitation. */
void ClearPrecipitation(int DropX[], int DropY[], 
                        int DropC[], int DropT[],
                        int offset, int *total_precip);

/* Redraw all the precipitation. */
void DrawAllPrecipitation(int precip_type, int bottom_x, 
                          int bottom_y, int precip_color);

/* Redraw the landscape (including the windmill, creature, etc. */
void DrawLandscape( int anim_time, int creature_pos, int creature_hits);

void DrawRainDrop (int x, int y, int color);
void DrawSnowDrop (int x, int y, int color);
void DrawHailDrop (int x, int y, int color);

/* Return an integer which tells what KIND of click there was. */
int  ClassifyMouseClick(int mouse_x, int mouse_y);

/* Call an appropriate function to handle a button click. */
void handle_button(int x, int y, int *current_precip, 
                   int *current_color, int *clear_weather,
                   int *fewer_drops);

/* Shoots a lightning bolt from the heavens. What's the fun */
/* of being a weather god if you can't be Zeus?             */
void lightning_bolt(int x_0, int color);


/****************************
*     Main                  *
****************************/

/* 
   main() has two chief purposes: to contain the important variables 
   and initialize them, and to contain the "event loop," which 
   constantly looks to see if an event has happened, and then 
   processes the event by calling an appropriate function.
*/
int main(void)
{
  int quit, mouse_x, mouse_y, anim_time, lightning_flag, lightning_x,
          precip_type, precip_color, creature_pos, lightning_color,
          creature_trend, current_precip, current_color, mouse_click,
          event, fewer_flag, clear_flag, total_precip, i, creature_hits;
  int DropX [MAX_PRECIP_EVENTS], DropY [MAX_PRECIP_EVENTS],
          DropC [MAX_PRECIP_EVENTS], DropT [MAX_PRECIP_EVENTS];
  double wind;
  char key_hit;
  time_t t;

  wind           = .5;
  quit           = FALSE;
  anim_time      = 0;
  precip_type    = NONE;
  creature_pos   = -1200;
  creature_trend = 1;
  creature_hits  = 0;
  current_precip = NONE;
  current_color  = WHITE;
  total_precip   = 0;
  clear_flag     = FALSE; /* Set to TRUE if all the precip should   */
                          /* be cleared.                            */
  fewer_flag     = FALSE; /* Set to TRUE if some precip should be   */
                          /* cleared.                               */

  srand (time(&t));       /* Seed the random number generator. This */
                          /* is something you should do if you plan */
                          /* to use random numbers. Put it here in  */
                          /* your program and forget about it.      */

  GP142_open();           /* Open and init the GP142 Graphics Window*/
  GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.       */

  GP142_clear();          /* This will clear the window & paint it  */
  GP142_animate(ANI_RUN); /* white. Start animation so precips will */
                          /* grow.                                  */

  DrawLandscape(anim_time, creature_pos, creature_hits);
  DrawButtons(current_precip, current_color);     /* Show the buttons...*/ 
  ClearPrecipitation ( DropX, DropY, DropC, 
                           DropT, 0, &total_precip);


  /*
   * The main event loop:
   * --- ---- ----- -----
   * Wait for the next user action, such as a mouse click or keyboard
   * keypress, or a periodic update event (allowing us to display the
   * next frame of an animation -- not used int this program) and call
   * the appropriate function to handle it.  Repeat this until the 
   * user signals "quit".
   */
   while (!quit) {  /*this is the famous "event loop" */
      /*find out what has happened */
      event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

      switch (event) {
         case GP142_QUIT:
            quit = TRUE; /* Set flag to terminate loop. */
            break;
         case GP142_KBD:
                /* Handles keyboard action. Not needed here. */
            break;
         case GP142_MOUSE:
                /* Decide what to do if a mouse click occurred. */
                mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
                if (mouse_click == BUTTON) {
                   /* A button has been clicked.  Calls a function */
                                   /* to handle it. */
                   handle_button(mouse_x, mouse_y, &current_precip, 
                                                     &current_color, &fewer_flag,
                                                                 &clear_flag);
                   precip_type = current_precip;
                   precip_color = current_color;
                   if (clear_flag)
                      ClearPrecipitation(DropX, DropY, DropC,
                                         DropT, 0, &total_precip);
                                   if (fewer_flag)
                                          ClearPrecipitation(DropX, DropY, DropC,
                                                             DropT, FEWER_REMAIN, 
                                                             &total_precip);
                                } else if ( (current_precip != NONE)  && 
                                            (current_color  != NONE)  &&
                                            (total_precip   != MAX_PRECIP_EVENTS))
                                { 
							       if (current_precip == LIGHTNING)
								   {
								      lightning_flag = 1;
								      lightning_x    = mouse_x;
								      lightning_color= current_color;
								   }
								   else
								   {
                                      DropX[total_precip] = mouse_x;
                                      DropY[total_precip] = mouse_y;
                                      DropT[total_precip] = current_precip;
                                      DropC[total_precip] = current_color;
                                      total_precip++;
                                   } 
								}
            break;

         case GP142_PERIODIC:
                        for (i = 0; i < total_precip; i++)
                        {   
                       if (DropT[i] == SNOW)
                              DropY[i] -= 1;
               if (DropT[i] == RAIN)
                              DropY[i] -= 3;
                           if (DropT[i] == HAIL)
                              DropY[i] -= 5;
                           if (DropY[i] < GROUND) 
                           {
                                  DropY[i] = YMAX;
                  if (total_precip != MAX_PRECIP_EVENTS &&
                                          !(rand() % 8))
                                  {
                     DropX[total_precip] = DropX[i] - 10 +
                                                                   rand() % 20;
                                         DropY[total_precip] = YMAX - rand() % 20;
                                         DropC[total_precip] = DropC[i];
                                         DropT[total_precip] = DropT[i];
                                         total_precip++;
                                  }
                           }
                           if (DropY[i] < 100)
                                  DropY[i]--;
                           if (DropY[i] < 0)
                                  DropY[i]--;
                           if (DropY[i] < -100)
                                  DropY[i]--;
                           DropX[i] += (int) (rand() % 10 / 5 * wind);
                           if (DropX[i] < -XMAX || DropX[i] > XMAX)
                              DropX[i] = -DropX[i];
                        }

            anim_time++;
                           
            wind += .2 * (rand() % 21 - 10) - .03 * wind;
   
            creature_pos += creature_trend;
            if (creature_pos > -110 && rand() % 2)
               creature_trend --;
			if (creature_trend < 0 && creature_pos < -250)
			{
		       creature_pos = -1200;
			   creature_trend = 1;
			}
            if (!(rand() % 28))
               creature_trend++;
            break;
         default:
            break;
          }  /* End switch. */

    
          /* Redraw everything */
      DrawLandscape(anim_time, creature_pos, creature_hits);
      DrawButtons(current_precip, current_color);
          for (i = 0; i < total_precip; i++)
      DrawAllPrecipitation(DropT[i], DropX[i], 
                           DropY[i], DropC[i]);
      if (lightning_flag)
	  {
	     if (rand() % 3 == FALSE) lightning_flag = FALSE;
		 lightning_bolt (lightning_x, lightning_color);
		 if (lightning_x > 100 && lightning_x <= 250 &&
			 creature_pos > -200) creature_hits++;
	  }
   }  /* End event loop. */

  /*
   * Wrap-up
   */
  GP142_close();         /* clean up and close graphics window   */

  return 0;
}  /* End main. */


/****************************
*     Functions             *
****************************/

void fill_array( int Array[], int offset, int size, int value)
{
   int i;
   if (offset < 0) offset = 0;
   for (i = offset; i < size; i++)
   {
      Array[i] = value;
   }
}

void  ClearPrecipitation(int DropX[], int DropY[],
                         int DropC[], int DropT[],
                         int offset, int *total_precip)
{
   fill_array(DropX, offset, *total_precip, 0);
   fill_array(DropY, offset, *total_precip, 0);
   fill_array(DropC, offset, *total_precip, 0);
   fill_array(DropT, offset, *total_precip, 0);
   *total_precip = offset;
   if (*total_precip < 0) *total_precip = 0;
}


void DrawRainDrop (int x, int y, int color) 
{ 
   GP142_triangleXY(color, x-2, y-1, x+2, y-1, x, y+4, 0);
   GP142_circleXY(color, x, y, 2);
}


void DrawSnowFlake(int x, int y, int color) 
{
   GP142_triangleXY(color, x-2, y-1, x+2, y-1, x, y+2, 0);
   GP142_triangleXY(color, x+2, y+1, x-2, y+1, x, y-2, 0);
}


void DrawHailStone(int x, int y, int color)
{
   GP142_triangleXY(color, x, y, x, y-5, x+4, y-3, 0);
   GP142_triangleXY(color, x, y, x, y-5, x-3, y-4, 0);
}


void DrawAllPrecipitation(int precip_type, int x, int y, int color)
{
   switch (precip_type) 
   {
      case RAIN:
         DrawRainDrop (x, y, color);
         break;
      case SNOW:
         DrawSnowFlake(x, y, color);
         break;
      case HAIL:
         DrawHailStone(x, y, color);
         break;
      default:
         break;
   } /* End switch. */
}


int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
   if ((mouse_x < -XMAX + BUTTON_WIDTH) &&
      (mouse_y < YMAX) &&
      (mouse_y > (YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
      return BUTTON;
   else
     return NONE;
}


void draw_quad(int color, int x1, int y1, int x2, int y2,
                          int x3, int y3, int x4, int y4)
{
   GP142_triangleXY( color, x1, y1, x2, y2, x3, y3, FILL);
   GP142_triangleXY( color, x1, y1, x4, y4, x3, y3, FILL);
}


int windmill_x(double offset, int radius, int anim_time)
{
	return (int) (WINDMILL_X_SQUISH * radius * 
		          cos (anim_time / WINDMILL_SPEED + offset) + 
				  WINDMILL_X);
}


int windmill_y(double offset, int radius, int anim_time)
{
	return (int) (radius * sin (-anim_time / WINDMILL_SPEED -
		         offset) + WINDMILL_Y);
}


void lightning_bolt(int x_0, int color)
{
	int y_0, x_1, y_1, x_2[LIGHTNING_SPLITS + 1], 
		y_2[LIGHTNING_SPLITS + 1], x_3, y_3, 
		branches_1, branches_2, i, j;
	y_0 = YMAX + 5;
	x_1 = x_0 + rand() % 100 - 50;
	y_1 = y_0 - rand() % 100 - 80;
	GP142_triangleXY(color, x_0 - 8, y_0,
		                    x_0 + 8, y_0,
							x_1    , y_1,
							FILL);
	branches_1 = rand() % LIGHTNING_SPLITS + 1;
	for (i = 0; i < branches_1; i++)
	{
		x_2[i] = x_1 + rand() % 200 - 100;
		y_2[i] = y_1 - rand() % 150 - 80;
	    GP142_lineXY(color, x_1, y_1, x_2[i], y_2[i], 3);
        branches_2 = rand() % (LIGHTNING_SPLITS + 1);
		for (j = 0; j < branches_2; j++)
		{
			x_3 = x_2[i] + rand() % 200 - 100;
			y_3 = y_2[i] - rand() % 190 - 50;
			GP142_lineXY(color, x_2[i], y_2[i], x_3, y_3, 2);
		}
	}
}


void DrawLandscape(int anim_time, int creature_pos, int creature_hits)
{  
  int sun_x, sun_y, moon_x, moon_y, sky_color;

  sun_x  = (int) (300 * cos (anim_time / 60.0) + 100);
  sun_y  = (int) (0.6 * 300 * sin (anim_time / 60.0));
  moon_x = (int) (300 * cos (anim_time / 60.0 + PI) + 100);
  moon_y = (int) (0.6 * 300 * sin (anim_time / 60.0 + PI));

  if (sun_y > 100) sky_color = ICE_BLUE;
  if (sun_y < -100) sky_color = BLACK;
  if (sun_y <= 100 && sun_y > 0) sky_color = BLUE;
  if (sun_y <= 0 && sun_y >= -100) sky_color = DUSTY_PLUM;

  /* Draw the sky first. */
  GP142_rectangleXY(sky_color, -XMAX, -YMAX,
                    XMAX, YMAX, FILL);
 
  /* Stars if it's night time. */
  if (sky_color == BLACK)
  {
	GP142_circleXY(WHITE, -185, 140, 4);
    GP142_circleXY((anim_time + 3)% 25, -120, 140, 3);
	GP142_circleXY(YELLOW, -40, 200, 2);
	GP142_circleXY(WHITE, -200, 160, 4);
	GP142_circleXY(WHITE, 10, 170, 2);
	GP142_circleXY(RED, 70, 180, 2);
	GP142_circleXY(YELLOW, 80, 130, 3);
	GP142_circleXY(WHITE, 120, 190, 2);
    GP142_circleXY(WHITE, 160, 200, 3);
	GP142_circleXY(WHITE, -10, 80, 4);
	GP142_circleXY(WHITE, 190, 210, 2);
	GP142_circleXY(WHITE, -220, 180, 2);
	GP142_circleXY(WHITE, -250, 160, 3);
	GP142_circleXY(WHITE, 200, 150, 3);
	GP142_circleXY(WHITE, 230, 230, 1);
	GP142_circleXY(WHITE, 250, 200, 2);
	GP142_circleXY(WHITE, -245, 170, 2);
	GP142_circleXY(WHITE, -170, 220, 4);
	GP142_circleXY((anim_time + 6) % 25, 170, 110, 3);
	GP142_circleXY(YELLOW, 200, 100, 3);
	GP142_circleXY((anim_time) % 25, rand() % 500 - 250, rand() % 250, 1);
	GP142_circleXY(WHITE, rand() % 500 - 250, rand() % 250, 1);
	GP142_circleXY(WHITE, rand() % 500 - 250, rand() % 250, 1);
	GP142_circleXY(WHITE, rand() % 500 - 250, rand() % 250, 1);
  }

  /* Draw the sun.       */
  GP142_circleXY(YELLOW, sun_x, sun_y , 35);

  /* Draw the moon.      */
  GP142_circleXY(WHITE, moon_x, moon_y, 20);

  /* Let's get some hills in there, shall we?  */
  GP142_circleXY(PURPLE, 50, -400, 450);
  GP142_circleXY(NAVY_BLUE, -250, -200, 300);

  if (creature_pos > -250)
  {
  /* Uh-oh, there's something behind the hill! */
  GP142_circleXY((MAGENTA + creature_hits) % 25, 200, 
	             creature_pos, 100);          /* Head.    */
  GP142_circleXY((CHALK + creature_hits) % 25, 165, 
	             creature_pos + 25, 35);      /* Eye.     */
  GP142_circleXY((WHITE + creature_hits) % 25,
	             235, creature_pos + 25, 32); /* Eye.     */
  GP142_circleXY((BLACK + creature_hits) % 25, 
	             165, creature_pos + 25, 18); /* Iris.    */
  GP142_circleXY((RED + creature_hits) % 25, 
	             235, creature_pos + 25, 22); /* Iris.    */
  GP142_lineXY((DUSTY_PLUM + creature_hits) % 25,
	             200, creature_pos + 40,      /* Eyebrow. */
                 120, creature_pos + 60, 35);
  GP142_lineXY((DUSTY_PLUM + creature_hits) %25, 
   	             200, creature_pos + 40,   /* Eyebrow. */
                 280, creature_pos + 60, 35);
  }

  /* Draw the foreground hills. */
  GP142_circleXY(FOREST_GREEN, -100, -900, 850);
  GP142_circleXY(FOREST_GREEN, 300, -1000, 900);

  /* Draw the road.             */
  draw_quad(BLACK, -XMAX, -220, -XMAX, -YMAX,-200, -YMAX, 700, -50);
  GP142_lineXY(YELLOW, -XMAX, -YMAX+5, 700, -50, 2);

  /* Draw the windmill.         */
  draw_quad( CHALK, -200, -180, -185, -85, -140, -80, -120, -170);
  draw_quad( LT_GRAY, -200, -180, -220, -170, -200, -80, -185, -85);
  draw_quad( WHITE, -185, -85, -140, -80, -150, -75, -200, -80);

  GP142_printfXY(BLACK, -180, -113, 8, "WELCOME");
  GP142_printfXY(BLACK, -170, -120, 6, "TO");
  GP142_printfXY(BLACK, -188, -140, 14, "KELLY'S");
  GP142_printfXY(BLACK, -188, -160, 14, "WORLD");

  /* Draw the windmill blades.  */
  GP142_triangleXY(BROWN, 
          windmill_x(-WINDMILL_BLADE_SIZE, WINDMILL_RADIUS, anim_time),
		  windmill_y(-WINDMILL_BLADE_SIZE, WINDMILL_RADIUS, anim_time),
          windmill_x(WINDMILL_BLADE_SIZE, WINDMILL_RADIUS, anim_time),                        
          windmill_y(WINDMILL_BLADE_SIZE, WINDMILL_RADIUS, anim_time),
		  windmill_x(PI, WINDMILL_RADIUS - 10, anim_time),
          windmill_y(PI, WINDMILL_RADIUS - 10, anim_time),
          FILL);
  GP142_triangleXY(BROWN, 
	      windmill_x(-WINDMILL_BLADE_SIZE - PI, WINDMILL_RADIUS, anim_time),                              
          windmill_y(-WINDMILL_BLADE_SIZE - PI, WINDMILL_RADIUS, anim_time),   
          windmill_x(WINDMILL_BLADE_SIZE - PI, WINDMILL_RADIUS, anim_time),
          windmill_y(WINDMILL_BLADE_SIZE - PI, WINDMILL_RADIUS, anim_time),
          windmill_x(0.0, WINDMILL_RADIUS - 10, anim_time),
          windmill_y(0.0, WINDMILL_RADIUS - 10, anim_time),                                          
          FILL);
  GP142_triangleXY(BROWN, 
          windmill_x(-WINDMILL_BLADE_SIZE - PI/2.0, WINDMILL_RADIUS, anim_time),     
          windmill_y(-WINDMILL_BLADE_SIZE - PI/2.0, WINDMILL_RADIUS, anim_time),  
          windmill_x(WINDMILL_BLADE_SIZE - PI/2.0, WINDMILL_RADIUS, anim_time), 
          windmill_y(WINDMILL_BLADE_SIZE - PI/2.0, WINDMILL_RADIUS, anim_time),
          windmill_x(PI/2.0, WINDMILL_RADIUS - 10, anim_time),
          windmill_y(PI/2.0, WINDMILL_RADIUS - 10, anim_time),
          FILL);
  GP142_triangleXY(BROWN, 
          windmill_x(PI/2.0 - WINDMILL_BLADE_SIZE, WINDMILL_RADIUS, anim_time),
          windmill_y(PI/2.0 - WINDMILL_BLADE_SIZE, WINDMILL_RADIUS, anim_time),
          windmill_x(PI/2.0 + WINDMILL_BLADE_SIZE, WINDMILL_RADIUS, anim_time), 
          windmill_y(PI/2.0 + WINDMILL_BLADE_SIZE, WINDMILL_RADIUS, anim_time),
          windmill_x(-PI/2.0, WINDMILL_RADIUS - 10, anim_time),     
          windmill_y(-PI/2.0, WINDMILL_RADIUS - 10, anim_time),
          FILL);

  GP142_circleXY(DUSTY_PLUM, -163, -83, 20);
  GP142_circleXY(BLACK, -163, -83, 16);
  GP142_circleXY(RED, -163, -83, 6);
  GP142_lineXY(BROWN,     
          (int) (7* cos(anim_time/10.0) - 163),      
          (int) (7*-sin(anim_time/10.0) - 83),      
          (int) (7*-cos(anim_time/10.0) - 163),      
          (int) (7* sin(anim_time/10.0) - 83),      
          3);
} /* End DrawLandscape. */


/* Figure out which button was clicked. */
void handle_button(int x, int y, int *current_precip, 
                                   int *current_color, int *fewer_drops,
                                   int *clear_weather)
{
   int max_speed  = 80;
   int buttonNum  = 0;
   *clear_weather = FALSE; /* Assume we don't replant.   */
   *fewer_drops   = FALSE;

  /* If we're outside of this area, we could not have    */
  /* clicked a button.                                   */
  if (x > -XMAX + BUTTON_WIDTH)  return;

  /* We know the mouse clicked in the column of buttons. */
  buttonNum = (YMAX - y)/BUTTON_HEIGHT;    

  switch(buttonNum) {
  case 0:
    *current_precip = RAIN;
    break;
  case 1:
    *current_precip = SNOW;
    break;
  case 2:
    *current_precip = HAIL;
    break;
  case 3:
	*current_precip = LIGHTNING;
	break;
  case 4:
    *current_color = WHITE;
    break;
  case 5:
    *current_color = BLUE;
    break;
  case 6:
    *current_color = (int) (rand() % 24); 
        /* 24 colors to choose from */
    break;
  case 7:
        *fewer_drops   = TRUE;
        break;
  case 8:
    *clear_weather = TRUE;
    break; /* Signal to clear up the weather */
  default:
    break;
  }
}


/* Draws the buttons. */
void DrawButtons(int current_precip, int current_color)
{
  int i, text_offset = -XMAX + 15, font_size = 16;

  /* Draw rectangles for each button. */
  for(i = 0; i < NUM_BUTTONS; i++) {
    GP142_rectangleXY(BLACK,
                      -XMAX + 4,
                      YMAX - i * BUTTON_HEIGHT - 2,
                      -XMAX + BUTTON_WIDTH,
                      YMAX - (i + 1)*BUTTON_HEIGHT - 2, 1);
  }

  /* Display the button text. "Selected buttons are highlighted */
  /* (i.e., have a different color).                            */
  i = YMAX - 25;
  if (current_precip == RAIN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, 
                       font_size, "Rain");  
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i,
                       font_size, "Rain");        

  i -= BUTTON_HEIGHT;
  if (current_precip == SNOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, 
                       font_size, "Snow");
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, 
                       font_size, "Snow");

  i -= BUTTON_HEIGHT;
  if (current_precip == HAIL)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, 
                       font_size, "Hail");
  else
        GP142_printfXY(UNSELECTED_COLOR, text_offset, i,
                       font_size, "Hail");
 
  i -= BUTTON_HEIGHT;
  if (current_precip == LIGHTNING)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, 
	                   font_size, "Lightning");
  else
	    GP142_printfXY(UNSELECTED_COLOR, text_offset, i,
		               font_size, "Lightning");

  /* Buttons for Colors */
  i -= BUTTON_HEIGHT;
  if (current_color == WHITE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, 
                       font_size, "White"); 
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, 
                       font_size, "White");

  i -= BUTTON_HEIGHT;
  if (current_color == BLUE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, 
                       font_size, "Blue");
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, 
                       font_size, "Blue");

  i -= BUTTON_HEIGHT;
  if (current_color != WHITE && current_color != BLUE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, 
                       font_size, "Random:%d", current_color);
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, 
                       font_size, "Random");

  /* These buttons is never "selected" */
  i -= BUTTON_HEIGHT;
  GP142_printfXY(UNSELECTED_COLOR, text_offset, i, 
                     font_size, "Fewer");

  i -= BUTTON_HEIGHT;
  GP142_printfXY(UNSELECTED_COLOR, text_offset, i, 
                     font_size, "Cease!");
}
